; ---USAGE---

; `python3 ok -q QUESTION`

; e.g. `python3 ok -q warm_up`


;;; Discussion 10 - Scheme, Scheme Lists ;;;


; Q4 - warm_up
;;; Tests
; (car (cdr (cdr (cdr s))))
; expect 3

(define s '(5 4 (1 2) 3 7))


; Q2 - fib
;;; Tests
; (fib 0)
; expect 0
; (fib 1)
; expect 1
; (fib 10)
; expect 55

(define (fib n)
    (if (<= n 1)
        n
        (+ (fib (- n 1)) (fib (- n 2))))
)


; Q5 - duplicate
;;; Tests
; (duplicate '(1 2 3 4))
; expect (1 1 2 2 3 3 4 4)

(define (duplicate lst)
   (if (null? lst)
       lst
       (cons (car lst) (cons (car lst) (duplicate (cdr lst)))))
)


; Q6 - insert
;;; Tests
; (insert 1 '(2 3 4) 0)
; expect (1 2 3 4)
; (insert 5 '(2 3 4) 3)
; expect (2 3 4 5)
; (insert 3 '(1 2 4 5) 2)
; expect (1 2 3 4 5)

(define (insert element lst index)
   (if (= index 0)
       (cons element lst)
       (cons (car lst) (insert element (cdr lst) (- index 1))))
)
